package es.juntadeandalucia.eni.componentes;

/**
 * @author everis
 */

import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * The Class AccesoSello.
 */
public class JAcceso extends JVentana {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 7397124523383560013L;

	/** The pnl botones. */
	private JPanel pnlBotones;

	/** The escribir documento. */
	private JButton escribirDocumento;

	/** The leer documento. */
	private JButton leerDocumento;
	
	/** The escribir expediente. */
//	private JButton escribirExpediente;

	/** The leer expediente. */
	private JButton leerExpediente;

	/**
	 * Constructor principal.
	 */
	public JAcceso() {
		super();
		Box boxPrincipal = Box.createVerticalBox();
		crearBotones();
		boxPrincipal.add(pnlImagen);
		boxPrincipal.add(pnlBotones);
		add(boxPrincipal);
		leerDocumento.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				abrirFormularioLecturaDocumento();
			}
		});	
		escribirDocumento.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				abrirFormularioEscrituraDocumento();
			}
		});
//		escribirExpediente.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				abrirFormularioEscrituraExpediente();
//			}
//		});
		leerExpediente.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				abrirFormularioLecturaExpediente();
			}
		});
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	/**
	 * Abrir formulario lectura documento.
	 */
	protected void abrirFormularioLecturaDocumento() {
		setVisible(Boolean.FALSE);
		new JFormReadDoc(this, "Lectura Documento");
	}
	
	/**
	 * Abrir formulario escritura documento.
	 */
	protected void abrirFormularioEscrituraDocumento() {
		setVisible(Boolean.FALSE);
		new JFormWriteDoc(this, "Escritura Documento");
	}
	
	/**
	 * Abrir formulario lectura expediente.
	 */
	protected void abrirFormularioLecturaExpediente() {
		setVisible(Boolean.FALSE);
		new JFormReadExp(this, "Lectura Expediente");
	}

//	/**
//	 * Abrir formulario escritura expediente.
//	 */
//	protected void abrirFormularioEscrituraExpediente() {
//		setVisible(Boolean.FALSE);
//		new JFormWriteDoc(this, "Escritura Expediente");
//	}

	/**
	 * Mostrar.
	 */
	public void mostrar() {
		setVisible(Boolean.TRUE);
	}

	/**
	 * Crear botones.
	 */
	private void crearBotones() {

		Dimension dimension = new Dimension(260, 50);
		Cursor cursor = new Cursor(Cursor.HAND_CURSOR);
		
		leerDocumento = new JButton("Leer Documento");
		leerDocumento.setMaximumSize(dimension);
		leerDocumento.setIcon(new ImageIcon(getClass().getResource("/imagenes/readDoc.png")));
		leerDocumento.setIconTextGap(5);
		leerDocumento.setCursor(cursor);

		escribirDocumento = new JButton("Escribir Documento");
		escribirDocumento.setMaximumSize(dimension);
		escribirDocumento.setIcon(new ImageIcon(getClass().getResource("/imagenes/writeDoc.png")));
		escribirDocumento.setIconTextGap(5);
		escribirDocumento.setCursor(cursor);

		leerExpediente = new JButton("Leer Expediente");
		leerExpediente.setMaximumSize(dimension);
		leerExpediente.setIcon(new ImageIcon(getClass().getResource("/imagenes/readExp.png")));
		leerExpediente.setIconTextGap(5);
		leerExpediente.setCursor(cursor);
		
//		escribirExpediente = new JButton("Escribir Expediente");
//		escribirExpediente.setMaximumSize(dimension);
//		escribirExpediente.setIcon(new ImageIcon(getClass().getResource("/imagenes/writeExp.png")));
//		escribirExpediente.setIconTextGap(5);
//		escribirExpediente.setCursor(cursor);
		
		Box boxBotones = Box.createVerticalBox();
		boxBotones.setPreferredSize(new Dimension(260, 300));
		boxBotones.add(leerDocumento);
		boxBotones.add(Box.createVerticalStrut(20));
		boxBotones.add(escribirDocumento);
		boxBotones.add(Box.createVerticalStrut(20));
		boxBotones.add(leerExpediente);
//		boxBotones.add(Box.createVerticalStrut(20));
//		boxBotones.add(escribirExpediente);
		
		pnlBotones = new JPanel();
		pnlBotones.add(boxBotones);
	}

}