package es.juntadeandalucia.eni.componentes;

/**
 * @author everis
 */

import java.awt.Cursor;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;

import es.juntadeandalucia.eni.utilidades.Constantes;
import es.juntadeandalucia.nti.DocumentoEni;
import es.juntadeandalucia.nti.impl.ConversorException;

/**
 * The Class JFormReadDoc.
 */
public class JFormReadDoc extends JVentana {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** The Constant X. */
	private static final Integer X = 100;

	/** The Constant Y. */
	private static final Integer Y = 150;

	/** The Constant ANCHO. */
	private static final Integer ANCHO = 120;

	/** The Constant AMPLIACION_ANCHO. */
	private static final Integer AMPLIACION_ANCHO = 30;

	/** The Constant ALTO. */
	private static final Integer ALTO = 20;

	/** The Constant SEPARACION_ALTO. */
	private static final Integer SEPARACION_ALTO = 40;

	/** The Constant SEPARACION_ETIQUETA. */
	private static final Integer SEPARACION_ETIQUETA = 130;

	/** The panel menu. */
	private JPanel panelMenu = null;

	/** The leer. */
	private JButton leer = null;

	/** The volver. */
	private JButton volver = null;

	/** The limpiar. */
	private JButton limpiar = null;

	/** The pantalla anterior. */
	private JVentana pantallaAnterior = null;

	/** The pantalla actual. */
	private JVentana pantallaActual = null;

	/** The examinar. */
	private JButton examinar;

	/** The ruta documentos label. */
	private JLabel rutaDocumentosLabel;

	/** The ruta documentos. */
	private JTextField rutaDocumentos;

	/** The pop up seleccion fichero. */
	private JFrame popupSeleccionFichero = new JFrame();

	/** The pop up seleccion fichero. */
	private JFileChooser seleccionFichero = new JFileChooser();

	/**
	 * Constructor principal.
	 * 
	 * @param anterior
	 *            the anterior
	 * @param cabecera
	 *            the cabecera
	 * @param usuario
	 *            the usuario
	 */
	public JFormReadDoc(JVentana anterior, String cabecera) {
		super(cabecera);
		setTitle(cabecera);
		metodoCierre(EXIT_ON_CLOSE);
		this.panelMenu = new JPanel();
		panelMenu.setLayout(null);
		crearComponentesVentana();
		getjContentPanel().add(panelMenu);
		setContentPane(getjContentPanel());
		seleccionFichero.addChoosableFileFilter(new FileNameExtensionFilter(
				"Fichero XML", "xml"));
		setVisible(Boolean.TRUE);
		pantallaAnterior = anterior;
		pantallaActual = this;
	}

	/**
	 * Crear componentes ventana.
	 * 
	 * @param usuario
	 *            the usuario
	 */
	private void crearComponentesVentana() {
		pnlImagen.setBounds(new Rectangle(0, 0, 550, 150));
		this.panelMenu.add(pnlImagen, null);
		this.panelMenu.add(getRutaDocumentosLabel(), null);
		this.panelMenu.add(getRutaDocumentos(), null);
		this.panelMenu.add(getExaminar(), null);
		this.panelMenu.add(getLeer(), null);
		this.panelMenu.add(getVolver(), null);
		this.panelMenu.add(getLimpiar(), null);
	}

	/**
	 * Gets the volver.
	 * 
	 * @return the volver
	 */
	private JButton getVolver() {
		if (this.volver == null) {
			this.volver = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/atras.png"));
			this.volver.setIcon(icon);
			this.volver.setIconTextGap(5);
			this.volver.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.volver.setBounds(new Rectangle(125, 250, 150, 40));
			this.volver.setText("Volver");
			this.volver.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					pantallaActual.setVisible(Boolean.FALSE);
					pantallaAnterior.setVisible(Boolean.TRUE);
				}
			});
		}
		return this.volver;
	}

	/**
	 * Gets the limpiar.
	 * 
	 * @return the limpiar
	 */
	private JButton getLimpiar() {
		if (this.limpiar == null) {
			this.limpiar = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/limpiar.png"));
			this.limpiar.setIcon(icon);
			this.limpiar.setIconTextGap(5);
			this.limpiar.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.limpiar.setBounds(new Rectangle(330, 250, 150, 40));
			this.limpiar.setText("Limpiar");
			this.limpiar.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					vaciarFormulario();
				}
			});
		}
		return this.limpiar;
	}

	/**
	 * Vaciar formulario.
	 */
	protected void vaciarFormulario() {
		rutaDocumentos.setText("");
	}

	/**
	 * Deshabilitar formulario.
	 */
	protected void deshabilitarFormulario() {
		this.setEnabled(Boolean.FALSE);
	}

	/**
	 * Habilitar formulario.
	 */
	protected void habilitarFormulario() {
		this.setEnabled(Boolean.TRUE);
	}

	/**
	 * Gets the leer.
	 * 
	 * @return the leer
	 */
	private JButton getLeer() {
		if (this.leer == null) {
			this.leer = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/leer.png"));
			this.leer.setIcon(icon);
			this.leer.setIconTextGap(5);
			this.leer.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.leer.setBounds(new Rectangle(530, 250, 150, 40));
			this.leer.setText("Leer");
			this.leer.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (rutaDocumentos.getText() != null
							&& !"".equals(rutaDocumentos.getText())) {
						if (!rutaDocumentos.getText().endsWith(".xml")) {
							JOptionPane
									.showMessageDialog(
											null,
											"El documento no tiene la extensión adecuada (xml)",
											"ERROR", Constantes.ERROR);
						} else {
							try {
								InputStream in = new FileInputStream(
										rutaDocumentos.getText());
								DocumentoEni documentoEni = new DocumentoEni(in);
								new JPanelMetadatosDoc(pantallaActual, "Datos Documento ENI", documentoEni, rutaDocumentos.getText());
							} catch (IOException ex) {
								JOptionPane.showMessageDialog(null,
										"Error en el acceso al fichero",
										"ERROR", Constantes.ERROR);
							} catch (ConversorException ex) {
								JOptionPane.showMessageDialog(null,
										"Error en la lectura del documento",
										"ERROR", Constantes.ERROR);
							}
						}
					} else {
						JOptionPane.showMessageDialog(null,
								"Debe introducir la ruta del documento",
								"ERROR", Constantes.ERROR);
					}
				}
			});
		}
		return this.leer;
	}

	/**
	 * Gets the ruta documentos label.
	 * 
	 * @return the ruta documentos label
	 */
	private JLabel getRutaDocumentosLabel() {
		if (this.rutaDocumentosLabel == null) {
			this.rutaDocumentosLabel = new JLabel();
			this.rutaDocumentosLabel.setText("Ruta fichero:");
			this.rutaDocumentosLabel.setBounds(new Rectangle(X, Y
					+ SEPARACION_ALTO, ANCHO, ALTO));
		}
		return this.rutaDocumentosLabel;
	}

	/**
	 * Gets the ruta documentos.
	 * 
	 * @return the ruta documentos
	 */
	public JTextField getRutaDocumentos() {
		if (this.rutaDocumentos == null) {
			this.rutaDocumentos = new JTextField();
			this.rutaDocumentos.setBounds(new Rectangle(
					X + SEPARACION_ETIQUETA, Y + SEPARACION_ALTO, ANCHO
							+ AMPLIACION_ANCHO * 8, ALTO));
			this.rutaDocumentos.setEditable(Boolean.FALSE);
		}
		return this.rutaDocumentos;
	}

	/**
	 * Gets the examinar.
	 * 
	 * @return the examinar
	 */
	private JButton getExaminar() {
		if (this.examinar == null) {
			this.examinar = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/examinar.png"));
			this.examinar.setIcon(icon);
			this.examinar.setIconTextGap(5);
			this.examinar.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.examinar.setBounds(new Rectangle(X + SEPARACION_ETIQUETA
					+ AMPLIACION_ANCHO * 12, Y + SEPARACION_ALTO, ANCHO
					+ AMPLIACION_ANCHO, ALTO));
			this.examinar.setText("Examinar");
			this.seleccionFichero.setFileSelectionMode(JFileChooser.FILES_ONLY);
			this.examinar.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					popUpFileChooser();
				}
			});
		}
		return this.examinar;
	}

	/**
	 * Pop up file chooser.
	 */
	private void popUpFileChooser() {
		String ruta = null;
		seleccionFichero.setAcceptAllFileFilterUsed(false);
		popupSeleccionFichero.add(seleccionFichero);
		Image icon = new ImageIcon(getClass().getResource(RUTA_ICONO))
				.getImage();
		popupSeleccionFichero.setIconImage(icon);
		seleccionFichero.setDialogTitle("Selección de fichero");
		int returnVal = seleccionFichero.showOpenDialog(popupSeleccionFichero);
		if (returnVal == 0) {
			File file = seleccionFichero.getSelectedFile();
			ruta = file.getPath();
			getRutaDocumentos().setText(ruta);
		}
	}

}