package es.juntadeandalucia.eni.componentes;

/**
 * @author everis
 */

import java.awt.Cursor;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;
import javax.swing.WindowConstants;
import javax.swing.filechooser.FileNameExtensionFilter;

import com.sun.org.apache.xml.internal.security.exceptions.Base64DecodingException;
import com.sun.org.apache.xml.internal.security.utils.Base64;
import com.toedter.calendar.JDateChooser;

import es.juntadeandalucia.eni.utilidades.Constantes;
import es.juntadeandalucia.nti.DocumentoEni;
import es.juntadeandalucia.nti.impl.ConversorException;
import es.juntadeandalucia.nti.util.FirmaEni;
import es.juntadeandalucia.nti.xsd.types.EstadoElaboracionDocumento;
import es.juntadeandalucia.nti.xsd.types.NombreFormatoDocumento;
import es.juntadeandalucia.nti.xsd.types.TipoDocumentalDocumento;
import es.juntadeandalucia.nti.xsd.types.TipoFirma;

/**
 * The Class JFormWriteDoc.
 */
public class JFormWriteDoc extends JVentana {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** The panel principal. */
	private JPanel panelPrincipal = null;

	/** The escribir. */
	private JButton escribir = null;

	/** The volver. */
	private JButton volver = null;

	/** The limpiar. */
	private JButton limpiar = null;

	/** The pantalla anterior. */
	private JVentana pantallaAnterior = null;

	/** The pantalla actual. */
	private JVentana pantallaActual = null;

	/** The panel contenido. */
	JPanel panelContenido = new JPanel();

	/** The panel metadatos. */
	JPanel panelMetadatos = new JPanel();

	/** The panel firma. */
	JPanel panelFirma = new JPanel();

	/** The panel botones. */
	JPanel panelBotones = new JPanel();

	/** The examinar. */
	private JButton examinar;

	/** The ruta documentos label. */
	private JLabel rutaDocumentosLabel;

	/** The ruta documentos. */
	private JTextField rutaDocumentos;

	/** The popup seleccion fichero. */
	private JFrame popupSeleccionFichero = new JFrame();

	/** The seleccion fichero. */
	private JFileChooser seleccionFichero = new JFileChooser();

	/** The formato label. */
	private JLabel formatoLabel;

	/** The formato. */
	private JComboBox formato;

	/** The identificador label. */
	private JLabel identificadorLabel;

	/** The identificador. */
	private JTextField identificador;

	/** The fecha label. */
	private JLabel fechaLabel;

	/** The fecha. */
	private JDateChooser fecha;

	/** The estado elaboracion label. */
	private JLabel estadoElaboracionLabel;

	/** The estado elaboracion. */
	private JComboBox estadoElaboracion;

	/** The tipo documental label. */
	private JLabel tipoDocumentalLabel;

	/** The tipo documental. */
	private JComboBox tipoDocumental;

	/** The id doc org label. */
	private JLabel idDocOrgLabel;

	/** The id doc org. */
	private JTextField idDocOrg;

	/** The organo label. */
	private JLabel organoLabel;

	/** The organo. */
	private JTextField organo;

	/** The csv eni label. */
	private JLabel csvEniLabel;

	/** The csv eni. */
	private JCheckBox csvEni;

	/** The csv label. */
	private JLabel csvLabel;

	/** The csv. */
	private JTextField csv;

	/** The tipo firma label. */
	private JLabel tipoFirmaLabel;

	/** The tipo firma. */
	private JComboBox tipoFirma;

	/** The firma label. */
	private JLabel firmaLabel;

	/** The firma. */
	private JTextArea firma;

	/** The scroll text area. */
	private JScrollPane scrollTextArea;

	/**
	 * Constructor principal.
	 * 
	 * @param anterior
	 *            the anterior
	 * @param cabecera
	 *            the cabecera
	 */
	public JFormWriteDoc(JVentana anterior, String cabecera) {
		super(new Dimension(850, 600), null, WindowConstants.EXIT_ON_CLOSE,
				false, cabecera);
		setTitle(cabecera);
		metodoCierre(EXIT_ON_CLOSE);
		this.panelPrincipal = new JPanel();
		panelPrincipal.setLayout(null);
		crearComponentesVentana();
		getjContentPanel().add(panelPrincipal);
		setContentPane(getjContentPanel());
		seleccionFichero.addChoosableFileFilter(new FileNameExtensionFilter(
				"*.*", calcularExtensiones()));
		setVisible(Boolean.TRUE);
		pantallaAnterior = anterior;
		pantallaActual = this;
	}

	/**
	 * Calcular extensiones.
	 * 
	 * @return the string[]
	 */
	private String[] calcularExtensiones() {
		NombreFormatoDocumento[] formatos = NombreFormatoDocumento.values();
		String[] formatosDocumento = new String[formatos.length];
		int i = 0;
		for (NombreFormatoDocumento formato : formatos) {
			formatosDocumento[i] = formato.getValue();
			i++;
		}
		return formatosDocumento;
	}

	/**
	 * Calcular lista extensiones.
	 * 
	 * @return the list
	 */
	private List<String> calcularListaExtensiones() {
		NombreFormatoDocumento[] formatos = NombreFormatoDocumento.values();
		List<String> formatosDocumento = new ArrayList<String>();
		for (NombreFormatoDocumento formato : formatos) {
			formatosDocumento.add(formato.getValue());
		}
		return formatosDocumento;
	}

	/**
	 * Crear componentes ventana.
	 * 
	 */
	private void crearComponentesVentana() {
		pnlImagen.setBounds(new Rectangle(0, 0, 550, 80));
		this.panelPrincipal.add(pnlImagen, null);
		this.panelPrincipal.add(getPanelContenido(), null);
		this.panelPrincipal.add(getPanelMetadatos(), null);
		this.panelPrincipal.add(getPanelFirma(), null);
		this.panelPrincipal.add(getPanelBotones(), null);
	}

	/**
	 * Gets the panel botones.
	 * 
	 * @return the panel botones
	 */
	private JPanel getPanelBotones() {
		this.panelBotones.setBounds(new Rectangle(10, 510, 830, 60));
		this.panelBotones.setLayout(null);
		this.panelBotones.add(getVolver(), null);
		this.panelBotones.add(getLimpiar(), null);
		this.panelBotones.add(getEscribir(), null);
		return this.panelBotones;
	}

	/**
	 * Gets the panel firma.
	 * 
	 * @return the panel firma
	 */
	private JPanel getPanelFirma() {
		this.panelFirma.setBounds(new Rectangle(10, 360, 830, 150));
		this.panelFirma.setLayout(null);
		this.panelFirma.setBorder(BorderFactory.createTitledBorder("Firma"));
		this.panelFirma.add(getCsvEniLabel(), null);
		this.panelFirma.add(getCsvEni(), null);
		this.panelFirma.add(getCsvLabel(), null);
		this.panelFirma.add(getCsv(), null);
		this.panelFirma.add(getTipoFirmaLabel(), null);
		this.panelFirma.add(getTipoFirma(), null);
		this.panelFirma.add(getFirmaLabel(), null);
		this.panelFirma.add(getFirma(), null);
		return this.panelFirma;
	}

	/**
	 * Gets the panel metadatos.
	 * 
	 * @return the panel metadatos
	 */
	private JPanel getPanelMetadatos() {
		this.panelMetadatos.setBounds(new Rectangle(10, 210, 830, 150));
		this.panelMetadatos.setLayout(null);
		this.panelMetadatos.setBorder(BorderFactory
				.createTitledBorder("Metadatos"));
		this.panelMetadatos.add(getIdentificadorLabel(), null);
		this.panelMetadatos.add(getIdentificador(), null);
		this.panelMetadatos.add(getFechaLabel(), null);
		this.panelMetadatos.add(getFecha(), null);
		this.panelMetadatos.add(getOrganoLabel(), null);
		this.panelMetadatos.add(getOrgano(), null);
		this.panelMetadatos.add(getEstadoElaboracionLabel(), null);
		this.panelMetadatos.add(getEstadoElaboracion(), null);
		this.panelMetadatos.add(getTipoDocumentalLabel(), null);
		this.panelMetadatos.add(getTipoDocumental(), null);
		this.panelMetadatos.add(getIdDocOrgLabel(), null);
		this.panelMetadatos.add(getIdDocOrg(), null);
		return this.panelMetadatos;
	}

	/**
	 * Gets the panel contenido.
	 * 
	 * @return the panel contenido
	 */
	private JPanel getPanelContenido() {
		this.panelContenido.setBounds(new Rectangle(10, 90, 830, 120));
		this.panelContenido.setLayout(null);
		this.panelContenido.setBorder(BorderFactory
				.createTitledBorder("Contenido"));
		this.panelContenido.add(getRutaDocumentosLabel(), null);
		this.panelContenido.add(getRutaDocumentos(), null);
		this.panelContenido.add(getExaminar(), null);
		this.panelContenido.add(getFormatoLabel(), null);
		this.panelContenido.add(getFormato(), null);
		return this.panelContenido;
	}

	/**
	 * Gets the volver.
	 * 
	 * @return the volver
	 */
	private JButton getVolver() {
		if (this.volver == null) {
			this.volver = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/atras.png"));
			this.volver.setIcon(icon);
			this.volver.setIconTextGap(5);
			this.volver.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.volver.setText("Volver");
			this.volver.setBounds(new Rectangle(170, 10, 150, 40));
			this.volver.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					pantallaActual.setVisible(Boolean.FALSE);
					pantallaAnterior.setVisible(Boolean.TRUE);
				}
			});
		}
		return this.volver;
	}

	/**
	 * Gets the limpiar.
	 * 
	 * @return the limpiar
	 */
	private JButton getLimpiar() {
		if (this.limpiar == null) {
			this.limpiar = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/limpiar.png"));
			this.limpiar.setIcon(icon);
			this.limpiar.setIconTextGap(5);
			this.limpiar.setBounds(new Rectangle(340, 10, 150, 40));
			this.limpiar.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.limpiar.setText("Limpiar");
			this.limpiar.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					vaciarFormulario();
				}
			});
		}
		return this.limpiar;
	}

	/**
	 * Gets the escribir.
	 * 
	 * @return the escribir
	 */
	private JButton getEscribir() {
		if (this.escribir == null) {
			this.escribir = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/escribir.png"));
			this.escribir.setIcon(icon);
			this.escribir.setIconTextGap(5);
			this.escribir.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.escribir.setText("Escribir");
			this.escribir.setBounds(new Rectangle(510, 10, 150, 40));
			this.escribir.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deshabilitarFormulario();
					if (validarFormulario()) {
						try {
							String ruta = escribir();
							JOptionPane.showMessageDialog(null,
									"Documento XML creado Correctamente",
									"INFORMACIÓN", Constantes.INFO);
							File path = new File(ruta);
							Desktop.getDesktop().open(path);
							vaciarFormulario();
						} catch (ConversorException ex) {
							JOptionPane.showMessageDialog(null,
									"Error en la conversión del documento",
									"ERROR", Constantes.ERROR);
						} catch (Base64DecodingException ex) {
							JOptionPane.showMessageDialog(null,
									"Error en la decodificación de la firma",
									"ERROR", Constantes.ERROR);
						} catch (FileNotFoundException ex) {
							JOptionPane.showMessageDialog(null,
									"El fichero no existe", "ERROR",
									Constantes.ERROR);
						} catch (IOException ex) {
							JOptionPane.showMessageDialog(null,
									"Error al escribir en fichero", "ERROR",
									Constantes.ERROR);
						}
					}
					habilitarFormulario();
				}
			});
		}
		return this.escribir;
	}

	protected boolean validarFormulario() {
		boolean valido = false;
		if (rutaDocumentos.getText() != null
				&& !"".equals(rutaDocumentos.getText())) {
			if (identificador.getText() != null
					&& !"".equals(identificador.getText())
					&& identificador.getText().length() == 30) {
				if (csvEni.isSelected() && csv.getText() != null
						&& !"".equals(csv.getText())
						&& csv.getText().length() != 6) {
					JOptionPane.showMessageDialog(null,
							"El campo csv debe tener 6 caracteres", "AVISO",
							Constantes.WARNING);
				}
				if (fecha.getDate() != null) {
					validarFecha(fecha.getDate());
					if (estadoElaboracion.getSelectedItem() != null) {
						EstadoElaboracionDocumento estado = EstadoElaboracionDocumento.EE04;
						if (estadoElaboracion.getSelectedItem().equals(estado)) {
							if (idDocOrg.getText() == null
									|| "".equals(idDocOrg.getText())) {
								JOptionPane
										.showMessageDialog(
												null,
												"El campo ID Documento Original es obligatorio para el estado seleccionado",
												"AVISO", Constantes.WARNING);
							}
						}
						if (tipoDocumental.getSelectedItem() != null) {
							if (organo.getText() != null
									&& !"".equals(organo.getText())
									&& esOrganoValido(organo.getText())) {
								if (csvEni.isSelected()) {
									if (csv.getText() == null
											|| "".equals(csv.getText())) {
										JOptionPane
												.showMessageDialog(
														null,
														"El campo CSV es obligatorio si selecciona establecer csv",
														"AVISO",
														Constantes.WARNING);
									} else {
										valido = true;
									}
								} else {
									if (firma.getText() != null
											&& !"".equals(firma.getText())) {
										if (tipoFirma.getSelectedItem() != null) {
											valido = true;
										} else {
											JOptionPane
													.showMessageDialog(
															null,
															"El campo Tipo Firma es obligatorio a menos que establezca el csv",
															"AVISO",
															Constantes.WARNING);
										}
									} else {
										JOptionPane
												.showMessageDialog(
														null,
														"El campo Firma es obligatorio a menos que establezca el csv",
														"AVISO",
														Constantes.WARNING);
									}
								}
							} else {
								if (!esOrganoValido(organo.getText())) {
									JOptionPane
											.showMessageDialog(
													null,
													"El campo Órgano no tiene un formato válido, debe comenzar por E, A o L seguido de 8 digitos",
													"AVISO", Constantes.WARNING);
								} else {
									JOptionPane.showMessageDialog(null,
											"El campo Órgano es obligatorio",
											"AVISO", Constantes.WARNING);
								}
							}
						} else {
							JOptionPane.showMessageDialog(null,
									"El campo Tipo Documental es obligatorio",
									"AVISO", Constantes.WARNING);
						}
					} else {
						JOptionPane.showMessageDialog(null,
								"El campo Estado Elaboración es obligatorio",
								"AVISO", Constantes.WARNING);
					}
				} else {
					JOptionPane
							.showMessageDialog(
									null,
									"El campo Fecha es obligatorio y debe tener un formato valido dd/MM/yyyy",
									"AVISO", Constantes.WARNING);
				}
			} else {
				JOptionPane.showMessageDialog(null,
						"El campo identificador debe tener 30 caracteres",
						"AVISO", Constantes.WARNING);
			}
		} else {
			JOptionPane
					.showMessageDialog(
							null,
							"Debe seleccionar un documento para continuar con el proceso",
							"AVISO", Constantes.WARNING);
		}
		return valido;
	}

	private boolean esOrganoValido(String codOrg) {
		Pattern pattern = Pattern.compile("[EAL]\\d{8}");
		Matcher matcher = pattern.matcher(codOrg);
		return matcher.matches();
	}

	/**
	 * Escribir.
	 * 
	 * @throws ConversorException
	 *             the conversor exception
	 * @throws Base64DecodingException
	 *             the base64 decoding exception
	 * @throws IOException
	 */
	protected String escribir() throws ConversorException,
			Base64DecodingException, IOException {
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		DocumentoEni docEni = new DocumentoEni();
		// Contenido del documento electrónico
		docEni.setNombreFormato((NombreFormatoDocumento) formato
				.getSelectedItem());
		File file = new File(rutaDocumentos.getText());
		InputStream input = new FileInputStream(file);
		docEni.setContenido(input);
		// Metadatos mínimos obligatorios
		docEni.establecerIdentificador(identificador.getText());
		docEni.setFechaCaptura(new Date());
		List<String> organos = new ArrayList<String>();
		organos.add(organo.getText());
		docEni.setOrganos(organos);
		docEni.setEstadoElaboracion((EstadoElaboracionDocumento) estadoElaboracion
				.getSelectedItem());
		docEni.setTipoDocumental((TipoDocumentalDocumento) tipoDocumental
				.getSelectedItem());
		EstadoElaboracionDocumento estado = EstadoElaboracionDocumento.EE04;
		if (estadoElaboracion.getSelectedItem().equals(estado)) {
			docEni.setIdentificadorDocumentoOrigen(idDocOrg.getText());
		}
		if (csvEni.isSelected()) {
			docEni.establecerCSV(csv.getText());
		} else {
			List<FirmaEni> firmas = new ArrayList<FirmaEni>();
			FirmaEni firmaEni = new FirmaEni();
			firmaEni.setTipoFirma((TipoFirma) tipoFirma.getSelectedItem());
			firmaEni.setFirmaBase64(Base64.decode(firma.getText().getBytes()));
			firmas.add(firmaEni);
			docEni.setFirmas(firmas);
		}
		// Conversión
		docEni.storeToXML(out);
		String rutaResultado = "";
		if (rutaDocumentos.getText().endsWith(".xml")) {
			rutaResultado = rutaDocumentos.getText() + ".xml";
		} else {
			rutaResultado = rutaDocumentos.getText().substring(0,
					rutaDocumentos.getText().lastIndexOf("."))
					+ ".xml";
		}
		OutputStream ficheroResultado = new FileOutputStream(rutaResultado);
		out.writeTo(ficheroResultado);
		ficheroResultado.close();
		out.close();
		return rutaResultado;
	}

	/**
	 * Vaciar formulario.
	 */
	protected void vaciarFormulario() {
		rutaDocumentos.setText("");
		formato.setSelectedItem(null);
		identificador.setText("");
		fecha.setDate(null);
		estadoElaboracion.setSelectedItem(null);
		tipoDocumental.setSelectedItem(null);
		idDocOrg.setText("");
		organo.setText("");
		csvEni.setSelected(Boolean.FALSE);
		csv.setText("");
		csv.setEnabled(Boolean.FALSE);
		csvLabel.setEnabled(Boolean.FALSE);
		tipoFirma.setSelectedItem(null);
		firma.setText("");
		tipoFirma.setEnabled(Boolean.TRUE);
		firma.setEnabled(Boolean.TRUE);
		tipoFirmaLabel.setEnabled(Boolean.TRUE);
		firmaLabel.setEnabled(Boolean.TRUE);
		idDocOrg.setEnabled(Boolean.FALSE);
		idDocOrgLabel.setEnabled(Boolean.FALSE);
	}

	/**
	 * Deshabilitar formulario.
	 */
	protected void deshabilitarFormulario() {
		this.setEnabled(Boolean.FALSE);
	}

	/**
	 * Habilitar formulario.
	 */
	protected void habilitarFormulario() {
		this.setEnabled(Boolean.TRUE);
	}

	/**
	 * Gets the formato label.
	 * 
	 * @return the formato label
	 */
	private JLabel getFormatoLabel() {
		if (this.formatoLabel == null) {
			this.formatoLabel = new JLabel();
			this.formatoLabel.setText("Formato:");
			this.formatoLabel.setBounds(new Rectangle(10, 70, 100, 20));
		}
		return this.formatoLabel;
	}

	/**
	 * Gets the formato.
	 * 
	 * @return the formato
	 */
	private JComboBox getFormato() {
		if (this.formato == null) {
			this.formato = obtenerComboBoxFormato();
			this.formato.setBounds(new Rectangle(110, 70, 100, 20));
			this.formato.setEnabled(Boolean.FALSE);
		}
		return this.formato;
	}

	/**
	 * Gets the ruta documentos label.
	 * 
	 * @return the ruta documentos label
	 */
	private JLabel getRutaDocumentosLabel() {
		if (this.rutaDocumentosLabel == null) {
			this.rutaDocumentosLabel = new JLabel();
			this.rutaDocumentosLabel.setText("Ruta documento:");
			this.rutaDocumentosLabel.setBounds(new Rectangle(10, 30, 100, 20));
		}
		return this.rutaDocumentosLabel;
	}

	/**
	 * Gets the ruta documentos.
	 * 
	 * @return the ruta documentos
	 */
	private JTextField getRutaDocumentos() {
		if (this.rutaDocumentos == null) {
			this.rutaDocumentos = new JTextField();
			this.rutaDocumentos.setBounds(new Rectangle(110, 30, 530, 20));
			this.rutaDocumentos.setEditable(Boolean.FALSE);
		}
		return this.rutaDocumentos;
	}

	/**
	 * Gets the examinar.
	 * 
	 * @return the examinar
	 */
	private JButton getExaminar() {
		if (this.examinar == null) {
			this.examinar = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/examinar.png"));
			this.examinar.setIcon(icon);
			this.examinar.setIconTextGap(5);
			this.examinar.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.examinar.setBounds(new Rectangle(640, 30, 150, 20));
			this.examinar.setText("Examinar");
			this.seleccionFichero.setFileSelectionMode(JFileChooser.FILES_ONLY);
			this.examinar.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					popUpFileChooser();
				}
			});
		}
		return this.examinar;
	}

	/**
	 * Pop up file chooser.
	 */
	private void popUpFileChooser() {
		String ruta = null;
		seleccionFichero.setAcceptAllFileFilterUsed(false);
		popupSeleccionFichero.getContentPane().add(seleccionFichero);
		Image icon = new ImageIcon(getClass().getResource(RUTA_ICONO))
				.getImage();
		popupSeleccionFichero.setIconImage(icon);
		seleccionFichero.setDialogTitle("Selección de fichero");
		int returnVal = seleccionFichero.showOpenDialog(popupSeleccionFichero);
		if (returnVal == 0) {
			File file = seleccionFichero.getSelectedFile();
			ruta = file.getPath();
			this.rutaDocumentos.setText(ruta);
			if (ruta.contains(".")) {
				String extension = ruta.substring(ruta.lastIndexOf(".") + 1)
						.toUpperCase();
				if (!calcularListaExtensiones().contains(extension)) {
					this.rutaDocumentos.setText("");
					JOptionPane.showMessageDialog(null,
							"Fichero seleccionado no válido", "AVISO",
							Constantes.WARNING);
					formato.getModel().setSelectedItem(null);
				} else {
					formato.getModel().setSelectedItem(
							NombreFormatoDocumento.fromValue(extension));
				}
			} else {
				this.rutaDocumentos.setText("");
				formato.getModel().setSelectedItem(null);
				JOptionPane.showMessageDialog(null,
						"Fichero seleccionado no válido", "AVISO",
						Constantes.WARNING);
			}
		}
	}

	/**
	 * Gets the tipo documental label.
	 * 
	 * @return the tipo documental label
	 */
	private JLabel getTipoDocumentalLabel() {
		if (this.tipoDocumentalLabel == null) {
			this.tipoDocumentalLabel = new JLabel();
			this.tipoDocumentalLabel.setText("Tipo Documental:");
			this.tipoDocumentalLabel.setBounds(new Rectangle(420, 70, 150, 20));
		}
		return this.tipoDocumentalLabel;
	}

	/**
	 * Gets the tipo documental.
	 * 
	 * @return the tipo documental
	 */
	private JComboBox getTipoDocumental() {
		if (this.tipoDocumental == null) {
			this.tipoDocumental = obtenerComboBoxTipo();
			this.tipoDocumental.setBounds(new Rectangle(570, 70, 200, 20));
		}
		return this.tipoDocumental;
	}

	/**
	 * Gets the estado elaboracion label.
	 * 
	 * @return the estado elaboracion label
	 */
	private JLabel getEstadoElaboracionLabel() {
		if (this.estadoElaboracionLabel == null) {
			this.estadoElaboracionLabel = new JLabel();
			this.estadoElaboracionLabel.setText("Estado Elaboración:");
			this.estadoElaboracionLabel.setBounds(new Rectangle(420, 30, 150,
					20));
		}
		return this.estadoElaboracionLabel;
	}

	/**
	 * Gets the estado elaboracion.
	 * 
	 * @return the estado elaboracion
	 */
	private JComboBox getEstadoElaboracion() {
		if (this.estadoElaboracion == null) {
			this.estadoElaboracion = obtenerComboBoxEstado();
			this.estadoElaboracion.setBounds(new Rectangle(570, 30, 200, 20));
			this.estadoElaboracion.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (estadoElaboracion.getSelectedItem() != null) {
						EstadoElaboracionDocumento estado = EstadoElaboracionDocumento.EE04;
						if (estadoElaboracion.getSelectedItem().equals(estado)) {
							idDocOrgLabel.setEnabled(Boolean.TRUE);
							idDocOrg.setEnabled(Boolean.TRUE);
						} else {
							idDocOrgLabel.setEnabled(Boolean.FALSE);
							idDocOrg.setEnabled(Boolean.FALSE);
							idDocOrg.setText("");
						}
					}
				}
			});
		}
		return this.estadoElaboracion;
	}

	/**
	 * Gets the identificador label.
	 * 
	 * @return the identificador label
	 */
	private JLabel getIdentificadorLabel() {
		if (this.identificadorLabel == null) {
			this.identificadorLabel = new JLabel();
			this.identificadorLabel.setText("Identificador:");
			this.identificadorLabel.setBounds(new Rectangle(10, 30, 100, 20));
		}
		return this.identificadorLabel;
	}

	/**
	 * Gets the identificador.
	 * 
	 * @return the identificador
	 */
	private JTextField getIdentificador() {
		if (this.identificador == null) {
			this.identificador = new JTextField();
			this.identificador.setBounds(new Rectangle(110, 30, 300, 20));
		}
		return this.identificador;
	}

	/**
	 * Gets the id doc org label.
	 * 
	 * @return the id doc org label
	 */
	private JLabel getIdDocOrgLabel() {
		if (this.idDocOrgLabel == null) {
			this.idDocOrgLabel = new JLabel();
			this.idDocOrgLabel.setText("Id Documento Original:");
			this.idDocOrgLabel.setBounds(new Rectangle(420, 110, 150, 20));
			this.idDocOrgLabel.setEnabled(Boolean.FALSE);
		}
		return this.idDocOrgLabel;
	}

	/**
	 * Gets the id doc org.
	 * 
	 * @return the id doc org
	 */
	private JTextField getIdDocOrg() {
		if (this.idDocOrg == null) {
			this.idDocOrg = new JTextField();
			this.idDocOrg.setBounds(new Rectangle(570, 110, 200, 20));
			this.idDocOrg.setEnabled(Boolean.FALSE);
		}
		return this.idDocOrg;
	}

	/**
	 * Gets the organo label.
	 * 
	 * @return the organo label
	 */
	private JLabel getOrganoLabel() {
		if (this.organoLabel == null) {
			this.organoLabel = new JLabel();
			this.organoLabel.setText("Órgano:");
			this.organoLabel.setBounds(new Rectangle(10, 110, 100, 20));
		}
		return this.organoLabel;
	}

	/**
	 * Gets the organo.
	 * 
	 * @return the organo
	 */
	private JTextField getOrgano() {
		if (this.organo == null) {
			this.organo = new JTextField();
			this.organo.setBounds(new Rectangle(110, 110, 300, 20));
		}
		return this.organo;
	}

	/**
	 * Gets the fecha label.
	 * 
	 * @return the fecha label
	 */
	private JLabel getFechaLabel() {
		if (this.fechaLabel == null) {
			this.fechaLabel = new JLabel();
			this.fechaLabel.setText("Fecha:");
			this.fechaLabel.setBounds(new Rectangle(10, 70, 100, 20));
		}
		return this.fechaLabel;
	}

	/**
	 * Gets the fecha.
	 * 
	 * @return the fecha
	 */
	private JDateChooser getFecha() {
		if (this.fecha == null) {
			this.fecha = new JDateChooser(new Date());
			this.fecha.setDateFormatString("dd/MM/yyyy");
			this.fecha
					.setBounds(new Rectangle(new Rectangle(110, 70, 300, 20)));
		}
		return this.fecha;
	}

	/**
	 * Gets the csv eni label.
	 * 
	 * @return the csv eni label
	 */
	private JLabel getCsvEniLabel() {
		if (this.csvEniLabel == null) {
			this.csvEniLabel = new JLabel();
			this.csvEniLabel.setText("Establecer CSV:");
			this.csvEniLabel.setBounds(new Rectangle(10, 30, 100, 20));
		}
		return this.csvEniLabel;
	}

	/**
	 * Gets the csv eni.
	 * 
	 * @return the csv eni
	 */
	private JCheckBox getCsvEni() {
		if (this.csvEni == null) {
			this.csvEni = new JCheckBox();
			this.csvEni
					.setBounds(new Rectangle(new Rectangle(110, 30, 20, 20)));
			this.csvEni.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (csvEni.isSelected()) {
						csvLabel.setEnabled(Boolean.TRUE);
						csv.setEnabled(Boolean.TRUE);
						tipoFirmaLabel.setEnabled(Boolean.FALSE);
						tipoFirma.setEnabled(Boolean.FALSE);
						tipoFirma.setSelectedItem(null);
						firmaLabel.setEnabled(Boolean.FALSE);
						firma.setEnabled(Boolean.FALSE);
						firma.setText("");
					} else {
						csv.setText("");
						csvLabel.setEnabled(Boolean.FALSE);
						csv.setEnabled(Boolean.FALSE);
						tipoFirmaLabel.setEnabled(Boolean.TRUE);
						tipoFirma.setEnabled(Boolean.TRUE);
						firmaLabel.setEnabled(Boolean.TRUE);
						firma.setEnabled(Boolean.TRUE);
					}
				}
			});
		}
		return this.csvEni;
	}

	/**
	 * Gets the csv label.
	 * 
	 * @return the csv label
	 */
	private JLabel getCsvLabel() {
		if (this.csvLabel == null) {
			this.csvLabel = new JLabel();
			this.csvLabel.setText("CSV:");
			this.csvLabel.setBounds(new Rectangle(150, 30, 60, 20));
			csvLabel.setEnabled(Boolean.FALSE);
		}
		return this.csvLabel;
	}

	/**
	 * Gets the csv.
	 * 
	 * @return the csv
	 */
	private JTextField getCsv() {
		if (this.csv == null) {
			this.csv = new JTextField();
			this.csv.setBounds(new Rectangle(210, 30, 100, 20));
			this.csv.setEnabled(Boolean.FALSE);
		}
		return this.csv;
	}

	/**
	 * Gets the tipo firma label.
	 * 
	 * @return the tipo firma label
	 */
	private JLabel getTipoFirmaLabel() {
		if (this.tipoFirmaLabel == null) {
			this.tipoFirmaLabel = new JLabel();
			this.tipoFirmaLabel.setText("Tipo Firma:");
			this.tipoFirmaLabel.setBounds(new Rectangle(330, 30, 100, 20));
		}
		return this.tipoFirmaLabel;
	}

	/**
	 * Gets the tipo firma.
	 * 
	 * @return the tipo firma
	 */
	private JComboBox getTipoFirma() {
		if (this.tipoFirma == null) {
			this.tipoFirma = obtenerComboBoxTipoFirma();
			this.tipoFirma.setBounds(new Rectangle(420, 30, 200, 20));
		}
		return this.tipoFirma;
	}

	/**
	 * Gets the firma label.
	 * 
	 * @return the firma label
	 */
	private JLabel getFirmaLabel() {
		if (this.firmaLabel == null) {
			this.firmaLabel = new JLabel();
			this.firmaLabel.setText("Firma Base64:");
			this.firmaLabel.setBounds(new Rectangle(10, 70, 100, 20));
		}
		return this.firmaLabel;
	}

	/**
	 * Gets the firma.
	 * 
	 * @return the firma
	 */
	private JScrollPane getFirma() {
		if (this.firma == null) {
			this.firma = new JTextArea(3, 5);
			this.firma.setLineWrap(Boolean.TRUE);
			this.firma.setWrapStyleWord(Boolean.TRUE);
			this.firma.setAutoscrolls(Boolean.TRUE);
			this.scrollTextArea = new JScrollPane(this.firma);
			this.scrollTextArea.setBounds(new Rectangle(110, 70, 700, 70));
			this.scrollTextArea
					.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		}
		return this.scrollTextArea;
	}

	/**
	 * Validar fecha.
	 * 
	 * @param date
	 *            the date
	 * @return the date
	 */
	private Date validarFecha(Date date) {
		Date actual = new Date();
		if (date != null) {
			boolean fechaCorrecta = false;
			String cadenaFecha = "";
			try {
				SimpleDateFormat sdfInput = new SimpleDateFormat("dd/MM/yyyy");
				sdfInput.setLenient(false);
				cadenaFecha = sdfInput.format(date);
				String[] array = cadenaFecha.split("/");
				if ("".equals(cadenaFecha)) {
					fechaCorrecta = true;
					actual = new Date();
				} else {
					if (array != null && array.length == 3
							&& array[2].length() == 4) {
						fechaCorrecta = true;
					}
					Date introducida = sdfInput.parse(cadenaFecha);
					if (introducida.before(actual) && fechaCorrecta) {
						actual = introducida;
					}
				}
			} catch (ParseException e) {
				actual = new Date();
				fechaCorrecta = false;
			}
			if (!fechaCorrecta) {
				JOptionPane.showMessageDialog(null,
						"La fecha introducida no es correcta.", "ERROR",
						Constantes.ERROR);
			}
		}
		return actual;
	}

	/**
	 * Obtener combo box tipo.
	 * 
	 * @return the j combo box
	 */
	private JComboBox obtenerComboBoxTipo() {
		JComboBox comboTipo = new JComboBox();
		TipoDocumentalDocumento[] valores = TipoDocumentalDocumento.values();
		comboTipo.addItem(null);
		for (TipoDocumentalDocumento valor : valores) {
			comboTipo.addItem(valor);
		}
		return comboTipo;
	}

	/**
	 * Obtener combo box estado.
	 * 
	 * @return the j combo box
	 */
	private JComboBox obtenerComboBoxEstado() {
		JComboBox comboEstado = new JComboBox();
		EstadoElaboracionDocumento[] valores = EstadoElaboracionDocumento
				.values();
		comboEstado.addItem(null);
		for (EstadoElaboracionDocumento valor : valores) {
			comboEstado.addItem(valor);
		}
		return comboEstado;
	}

	/**
	 * Obtener combo box formato.
	 * 
	 * @return the j combo box
	 */
	private JComboBox obtenerComboBoxFormato() {
		JComboBox comboFormato = new JComboBox();
		NombreFormatoDocumento[] valores = NombreFormatoDocumento.values();
		comboFormato.addItem(null);
		for (NombreFormatoDocumento valor : valores) {
			comboFormato.addItem(valor);
		}
		return comboFormato;
	}

	/**
	 * Obtener combo box tipo firma.
	 * 
	 * @return the j combo box
	 */
	private JComboBox obtenerComboBoxTipoFirma() {
		JComboBox comboTipoFirma = new JComboBox();
		TipoFirma[] valores = TipoFirma.values();
		comboTipoFirma.addItem(null);
		for (TipoFirma valor : valores) {
			if (!valor.equals(TipoFirma.TF01)) {
				comboTipoFirma.addItem(valor);
			}
		}
		return comboTipoFirma;
	}

}