package es.juntadeandalucia.eni.componentes;

/**
 * @author everis
 */

import java.awt.Cursor;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.WindowConstants;

import es.juntadeandalucia.eni.utilidades.Constantes;
import es.juntadeandalucia.nti.DocumentoEni;
import es.juntadeandalucia.nti.util.FirmaEni;
import es.juntadeandalucia.nti.xsd.types.EstadoElaboracionDocumento;
import es.juntadeandalucia.nti.xsd.types.NombreFormatoDocumento;
import es.juntadeandalucia.nti.xsd.types.TipoDocumentalDocumento;

/**
 * The Class JPanelMetadatos.
 */
public class JPanelMetadatosDoc extends JVentana {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** The panel principal. */
	private JPanel panelPrincipal = null;

	/** The volver. */
	private JButton cerrar = null;

	/** The pantalla anterior. */
	private JVentana pantallaAnterior = null;

	/** The pantalla actual. */
	private JVentana pantallaActual = null;

	/** The panel metadatos. */
	JPanel panelMetadatos = new JPanel();

	/** The panel botones. */
	JPanel panelBotones = new JPanel();

	/** The identificador label. */
	private JLabel identificadorLabel;

	/** The identificador. */
	private JLabel identificador;

	/** The fecha label. */
	private JLabel fechaLabel;

	/** The fecha. */
	private JLabel fecha;

	/** The estado elaboracion label. */
	private JLabel estadoElaboracionLabel;

	/** The estado elaboracion. */
	private JLabel estadoElaboracion;

	/** The tipo documental label. */
	private JLabel tipoDocumentalLabel;

	/** The tipo documental. */
	private JLabel tipoDocumental;

	/** The id doc org label. */
	private JLabel idDocOrgLabel;

	/** The id doc org. */
	private JLabel idDocOrg;

	/** The organo label. */
	private JLabel organoLabel;

	/** The organo. */
	private JLabel organo;

	/** The num Firmas label. */
	private JLabel numFirmasLabel;

	/** The num Firmas. */
	private JLabel numFirmas;

	/** The descarga label. */
	private JLabel descargaLabel;

	/** The descarga. */
	private JButton descarga;

	/**
	 * Constructor principal.
	 * 
	 * @param anterior
	 *            the anterior
	 * @param cabecera
	 *            the cabecera
	 */
	public JPanelMetadatosDoc(JVentana anterior, String cabecera,
			DocumentoEni eni, String ruta) {
		super(new Dimension(750, 650), null,
				WindowConstants.DO_NOTHING_ON_CLOSE, false, cabecera);
		setTitle(cabecera);
		metodoCierre(DO_NOTHING_ON_CLOSE);
		this.panelPrincipal = new JPanel();
		panelPrincipal.setLayout(null);
		crearComponentesVentana(eni, ruta);
		getjContentPanel().add(panelPrincipal);
		setContentPane(getjContentPanel());
		setVisible(Boolean.TRUE);
		pantallaAnterior = anterior;
		((JFormReadDoc) pantallaAnterior).deshabilitarFormulario();
		pantallaActual = this;
	}

	/**
	 * Crear componentes ventana.
	 * 
	 */
	private void crearComponentesVentana(DocumentoEni eni, String ruta) {
		pnlImagen.setBounds(new Rectangle(0, 0, 550, 80));
		this.panelPrincipal.add(pnlImagen, null);
		this.panelPrincipal.add(getPanelMetadatos(eni, ruta), null);
		this.panelPrincipal.add(getPanelBotones(), null);
	}

	/**
	 * Gets the panel botones.
	 * 
	 * @return the panel botones
	 */
	private JPanel getPanelBotones() {
		this.panelBotones.setBounds(new Rectangle(10, 540, 700, 60));
		this.panelBotones.setLayout(null);
		this.panelBotones.add(getCerrar(), null);
		return this.panelBotones;
	}

	/**
	 * Gets the panel metadatos.
	 * 
	 * @return the panel metadatos
	 */
	private JPanel getPanelMetadatos(DocumentoEni eni, String ruta) {
		this.panelMetadatos.setBounds(new Rectangle(10, 150, 720, 360));
		this.panelMetadatos.setLayout(null);
		this.panelMetadatos
				.setBorder(BorderFactory.createTitledBorder("Documento ENI: "
						+ ruta.substring(ruta.lastIndexOf(File.separator) + 1)));
		this.panelMetadatos.add(getIdentificadorLabel(), null);
		this.panelMetadatos.add(getIdentificador(eni.getIdentificador()), null);
		this.panelMetadatos.add(getFechaLabel(), null);
		this.panelMetadatos.add(getFecha(eni.getFechaCaptura()), null);
		this.panelMetadatos.add(getOrganoLabel(), null);
		this.panelMetadatos.add(getOrgano(eni.getOrganos()), null);
		this.panelMetadatos.add(getEstadoElaboracionLabel(), null);
		this.panelMetadatos.add(
				getEstadoElaboracion(eni.getEstadoElaboracion()), null);
		this.panelMetadatos.add(getTipoDocumentalLabel(), null);
		this.panelMetadatos.add(getTipoDocumental(eni.getTipoDocumental()),
				null);
		this.panelMetadatos.add(getIdDocOrgLabel(), null);
		this.panelMetadatos.add(
				getIdDocOrg(eni.getIdentificadorDocumentoOrigen()), null);
		this.panelMetadatos.add(getNumFirmasLabel(), null);
		this.panelMetadatos.add(getNumFirmas(eni.getFirmas()), null);
		this.panelMetadatos.add(getDescargaLabel(), null);
		this.panelMetadatos.add(
				getDescarga(eni.getContenido(), eni.getNombreFormato(), ruta),
				null);
		return this.panelMetadatos;
	}

	/**
	 * Gets the volver.
	 * 
	 * @return the volver
	 */
	private JButton getCerrar() {
		if (this.cerrar == null) {
			this.cerrar = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/cancel.png"));
			this.cerrar.setIcon(icon);
			this.cerrar.setIconTextGap(5);
			this.cerrar.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.cerrar.setText("Cerrar");
			this.cerrar.setBounds(new Rectangle(300, 10, 150, 40));
			this.cerrar.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					pantallaActual.dispose();
					((JFormReadDoc) pantallaAnterior).habilitarFormulario();
				}
			});
		}
		return this.cerrar;
	}

	/**
	 * Gets the tipo documental label.
	 * 
	 * @return the tipo documental label
	 */
	private JLabel getTipoDocumentalLabel() {
		if (this.tipoDocumentalLabel == null) {
			this.tipoDocumentalLabel = new JLabel();
			this.tipoDocumentalLabel.setText("Tipo Documental:");
			this.tipoDocumentalLabel.setBounds(new Rectangle(10, 190, 140, 20));
		}
		return this.tipoDocumentalLabel;
	}

	/**
	 * Gets the tipo documental.
	 * 
	 * @param tipoDocumentalDocumento
	 * 
	 * @return the tipo documental
	 */
	private JLabel getTipoDocumental(
			TipoDocumentalDocumento tipoDocumentalDocumento) {
		if (this.tipoDocumental == null) {
			this.tipoDocumental = new JLabel();
			this.tipoDocumental.setText(tipoDocumentalDocumento
					.getDescripcion());
			this.tipoDocumental.setBounds(new Rectangle(150, 190, 500, 20));
			this.tipoDocumental.setEnabled(Boolean.FALSE);
		}
		return this.tipoDocumental;
	}

	/**
	 * Gets the estado elaboracion label.
	 * 
	 * @return the estado elaboracion label
	 */
	private JLabel getEstadoElaboracionLabel() {
		if (this.estadoElaboracionLabel == null) {
			this.estadoElaboracionLabel = new JLabel();
			this.estadoElaboracionLabel.setText("Estado Elaboración:");
			this.estadoElaboracionLabel.setBounds(new Rectangle(10, 150, 140,
					20));
		}
		return this.estadoElaboracionLabel;
	}

	/**
	 * Gets the estado elaboracion.
	 * 
	 * @param estadoElaboracionDocumento
	 * 
	 * @return the estado elaboracion
	 */
	private JLabel getEstadoElaboracion(
			EstadoElaboracionDocumento estadoElaboracionDocumento) {
		if (this.estadoElaboracion == null) {
			this.estadoElaboracion = new JLabel();
			this.estadoElaboracion.setText(estadoElaboracionDocumento
					.getDescripcion());
			this.estadoElaboracion.setBounds(new Rectangle(150, 150, 500, 20));
			this.estadoElaboracion.setEnabled(Boolean.FALSE);
		}
		return this.estadoElaboracion;
	}

	/**
	 * Gets the identificador label.
	 * 
	 * @return the identificador label
	 */
	private JLabel getIdentificadorLabel() {
		if (this.identificadorLabel == null) {
			this.identificadorLabel = new JLabel();
			this.identificadorLabel.setText("Identificador:");
			this.identificadorLabel.setBounds(new Rectangle(10, 30, 140, 20));
		}
		return this.identificadorLabel;
	}

	/**
	 * Gets the identificador.
	 * 
	 * @param id
	 * 
	 * @return the identificador
	 */
	private JLabel getIdentificador(String id) {
		if (this.identificador == null) {
			this.identificador = new JLabel();
			this.identificador.setText(id);
			this.identificador.setBounds(new Rectangle(150, 30, 500, 20));
			this.identificador.setEnabled(Boolean.FALSE);
		}
		return this.identificador;
	}

	/**
	 * Gets the id doc org label.
	 * 
	 * @return the id doc org label
	 */
	private JLabel getIdDocOrgLabel() {
		if (this.idDocOrgLabel == null) {
			this.idDocOrgLabel = new JLabel();
			this.idDocOrgLabel.setText("Id Documento Original:");
			this.idDocOrgLabel.setBounds(new Rectangle(10, 230, 140, 20));
		}
		return this.idDocOrgLabel;
	}

	/**
	 * Gets the id doc org.
	 * 
	 * @param id
	 * 
	 * @return the id doc org
	 */
	private JLabel getIdDocOrg(String id) {
		if (this.idDocOrg == null) {
			this.idDocOrg = new JLabel();
			if (id != null && !"".equals(id)) {
				this.idDocOrg.setText(id);
			} else {
				this.idDocOrg.setText("N/A");
			}
			this.idDocOrg.setBounds(new Rectangle(150, 230, 500, 20));
			this.idDocOrg.setEnabled(Boolean.FALSE);
		}
		return this.idDocOrg;
	}

	/**
	 * Gets the organo label.
	 * 
	 * @return the organo label
	 */
	private JLabel getOrganoLabel() {
		if (this.organoLabel == null) {
			this.organoLabel = new JLabel();
			this.organoLabel.setText("Órgano:");
			this.organoLabel.setBounds(new Rectangle(10, 110, 140, 20));
		}
		return this.organoLabel;
	}

	/**
	 * Gets the organo.
	 * 
	 * @param organos
	 * 
	 * @return the organo
	 */
	private JLabel getOrgano(List<String> organos) {
		if (this.organo == null) {
			this.organo = new JLabel();
			this.organo.setBounds(new Rectangle(150, 110, 500, 20));
			if (organos != null && !organos.isEmpty()) {
				for (String org : organos) {
					String contenidoOrg = this.organo.getText();
					this.organo.setText(contenidoOrg + org + " ");
				}
			}
			this.organo.setEnabled(Boolean.FALSE);
		}
		return this.organo;
	}

	/**
	 * Gets the fecha label.
	 * 
	 * @return the fecha label
	 */
	private JLabel getFechaLabel() {
		if (this.fechaLabel == null) {
			this.fechaLabel = new JLabel();
			this.fechaLabel.setText("Fecha:");
			this.fechaLabel.setBounds(new Rectangle(10, 70, 140, 20));
		}
		return this.fechaLabel;
	}

	/**
	 * Gets the fecha.
	 * 
	 * @param date
	 * 
	 * @return the fecha
	 */
	private JLabel getFecha(Date date) {
		if (this.fecha == null) {
			this.fecha = new JLabel();
			this.fecha
					.setBounds(new Rectangle(new Rectangle(150, 70, 500, 20)));
			SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
			String strFecha = sdf.format(date);
			this.fecha.setText(strFecha);
			this.fecha.setEnabled(Boolean.FALSE);
		}
		return this.fecha;
	}

	/**
	 * Gets the num firmas label.
	 * 
	 * @return the num firmas label
	 */
	private JLabel getNumFirmasLabel() {
		if (this.numFirmasLabel == null) {
			this.numFirmasLabel = new JLabel();
			this.numFirmasLabel.setText("Nº Firmas:");
			this.numFirmasLabel.setBounds(new Rectangle(10, 270, 140, 20));
		}
		return this.numFirmasLabel;
	}

	/**
	 * Gets the num firmas label.
	 * 
	 * @param firmas
	 * 
	 * @return the num firmas label
	 */
	private JLabel getNumFirmas(List<FirmaEni> firmas) {
		if (this.numFirmas == null) {
			this.numFirmas = new JLabel();
			this.numFirmas.setBounds(new Rectangle(150, 270, 500, 20));
			if (firmas != null && !firmas.isEmpty()) {
				this.numFirmas.setText(firmas.size() + "");
			}
			this.numFirmas.setEnabled(Boolean.FALSE);
		}
		return this.numFirmas;
	}

	/**
	 * Gets the descarga label.
	 * 
	 * @return the descarga label
	 */
	private JLabel getDescargaLabel() {
		if (this.descargaLabel == null) {
			this.descargaLabel = new JLabel();
			this.descargaLabel.setText("Documento:");
			this.descargaLabel.setBounds(new Rectangle(10, 310, 140, 20));
		}
		return this.descargaLabel;
	}

	/**
	 * Gets the descarga.
	 * 
	 * @param formato
	 * @param contenido
	 * 
	 * @param enlace
	 * 
	 * @return the enlace link
	 */
	private JButton getDescarga(final byte[] contenido,
			final NombreFormatoDocumento formato, final String ruta) {
		if (this.descarga == null) {
			this.descarga = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/descarga.png"));
			this.descarga.setIcon(icon);
			this.descarga.setIconTextGap(5);
			this.descarga.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.descarga.setText("Descarga");
			this.descarga.setBounds(new Rectangle(150, 310, 150, 40));
			this.descarga.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						String destino = ruta.substring(0,
								ruta.lastIndexOf("."))
								+ "." + formato.getValue();
						FileOutputStream fileOuputStream = new FileOutputStream(
								destino);
						fileOuputStream.write(contenido);
						fileOuputStream.close();
						JOptionPane.showMessageDialog(null,
								"Documento descargado correctamente guardado en: "
										+ destino, "INFORMACIÓN",
								Constantes.INFO);
						File path = new File(destino);
						Desktop.getDesktop().open(path);
					} catch (FileNotFoundException ex) {
						JOptionPane.showMessageDialog(null,
								"El fichero no existe", "ERROR",
								Constantes.ERROR);
					} catch (IOException ex) {
						JOptionPane.showMessageDialog(null,
								"Error al escribir en fichero", "ERROR",
								Constantes.ERROR);
					}
				}
			});
		}
		return this.descarga;
	}
}