package es.juntadeandalucia.eni.componentes;

/**
 * @author everis
 */

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.WindowConstants;

import es.juntadeandalucia.eni.utilidades.Constantes;
import es.juntadeandalucia.nti.ExpedienteEni;
import es.juntadeandalucia.nti.util.CarpetaIndice;
import es.juntadeandalucia.nti.util.DocumentoIndice;
import es.juntadeandalucia.nti.util.ExpedienteIndice;
import es.juntadeandalucia.nti.util.InteresadoEni;

/**
 * The Class JPanelMetadatos.
 */
public class JPanelMetadatosExp extends JVentana {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** The panel principal. */
	private JPanel panelPrincipal = null;

	/** The panel metadatos. */
	private JPanel panelMetadatos = null;

	/** The panel botones. */
	private JPanel panelBotones = null;

	/** The pantalla anterior. */
	private JVentana pantallaAnterior = null;

	/** The pantalla actual. */
	private JVentana pantallaActual = null;

	/** The descarga. */
	private JButton descarga;

	/** The volver. */
	private JButton cerrar = null;

	/** The identificador. */
	private JLabel identificador;

	/** The Id especifico. */
	private JLabel IdEspecifico;

	/** The organo. */
	private JLabel organo;

	/** The interesado. */
	private JLabel interesados;

	/** The clasificacion. */
	private JLabel clasificacion;

	/** The fecha. */
	private JLabel fecha;

	/** The estado. */
	private JLabel estado;

	/** The Version nti. */
	private JLabel versionNTI;

	/** The Descarga. */
	private JLabel descargaLabel;

	/** The Fecha indice. */
	private JLabel fechaIndice;

	/** The Numero Firmas. */
	private JLabel nFirmas;

	/** The doc identificador. */
	private JLabel docIdentificador;

	/** The doc valor huella. */
	private JLabel docValorHuella;

	/** The doc funcion resumen. */
	private JLabel docFuncionResumen;

	/** The doc fecha incorporacion. */
	private JLabel docFechaIncorporacion;

	/** The doc orden. */
	private JLabel docOrden;

	/** The carp identificador. */
	private JLabel carpIdentificador;

	/** The metadato. */
	private JLabel expFecha;

	/** The alto panel. */
	public int altoPanel = 30;

	/** The pos panel inc. */
	public int posPanelInc;

	/** The pos bloque. */
	public int posBloqueDoc;

	/** The pos bloque carp. */
	public int posBloqueCarp;

	/** The pos bloque exp. */
	public int posBloqueExp;

	/** The pos doc. */
	public int posDoc;

	/** The pos horizontal label. */
	public int posHorizontalLabel;

	/** The pos horizontal content. */
	public int posHorizontalContent;

	/** The widht label. */
	public int widhtLabel;

	/** The widht content. */
	public int widhtContent;

	/** The height bloque. */
	public int heightBloque;

	/**
	 * Constructor principal.
	 * 
	 * @param anterior
	 *            the anterior
	 * @param cabecera
	 *            the cabecera
	 * @param eni
	 *            the eni
	 * @param ruta
	 *            the ruta
	 */
	public JPanelMetadatosExp(JVentana anterior, String cabecera,
			ExpedienteEni eni, String ruta) {
		super(new Dimension(750, 650), null,
				WindowConstants.DO_NOTHING_ON_CLOSE, false, cabecera);
		setTitle(cabecera);
		metodoCierre(DO_NOTHING_ON_CLOSE);

		this.panelPrincipal = new JPanel();
		panelPrincipal.setLayout(new BorderLayout());

		crearComponentesVentana(eni, ruta);
		this.panelPrincipal.setPreferredSize(new Dimension(750,
				altoPanel + 180));
		this.cerrar.setBounds(new Rectangle(300, altoPanel + 130, 150, 40));
		final JScrollPane scroll = new JScrollPane(panelPrincipal,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scroll.getVerticalScrollBar().setUnitIncrement(16);
		setContentPane(getjContentPanel());
		getjContentPanel().add(scroll);

		setVisible(Boolean.TRUE);
		pantallaAnterior = anterior;
		((JFormReadExp) pantallaAnterior).deshabilitarFormulario();
		pantallaActual = this;
	}

	/**
	 * Crear componentes ventana.
	 * 
	 * @param eni
	 *            the eni
	 * @param ruta
	 *            the ruta
	 */
	private void crearComponentesVentana(ExpedienteEni eni, String ruta) {
		pnlImagen.setBounds(new Rectangle(0, 0, 550, 80));
		this.panelPrincipal.add(pnlImagen, null);
		this.panelPrincipal.add(getPanelMetadatos(eni, ruta), null);
		this.panelPrincipal.add(getPanelBotones(), null);
	}

	/**
	 * Gets the panel botones.
	 * 
	 * @return the panel botones
	 */
	private JPanel getPanelBotones() {
		this.panelBotones = new JPanel();
		this.panelBotones.setBounds(new Rectangle(10, 540, 700, 60));
		this.panelBotones.setLayout(null);
		this.panelBotones.add(getCerrar(), null);
		return this.panelBotones;
	}

	/**
	 * Gets the panel metadatos.
	 * 
	 * @param eni
	 *            the eni
	 * @param ruta
	 *            the ruta
	 * @return the panel metadatos
	 */
	private JPanel getPanelMetadatos(ExpedienteEni eni, String ruta) {
		posHorizontalLabel = 10;
		posHorizontalContent = 110;
		widhtLabel = 90;
		widhtContent = 580;

		this.panelMetadatos = new JPanel();
		this.panelMetadatos.setLayout(null);
		this.panelMetadatos
				.setBorder(BorderFactory.createTitledBorder("Expediente ENI: "
						+ ruta.substring(ruta.lastIndexOf(File.separator) + 1)));

		// IDENTIFICADOR
		if (eni.getIdentificador() != null) {
			this.panelMetadatos.add(getLabel("Identificador",
					this.identificador));
			this.panelMetadatos.add(getContent(eni.getIdentificador(),
					this.identificador));
			altoPanel = altoPanel + 30;
		}

		// ID ESPECIFICO
		if (eni.getIdEspecifico() != null) {
			this.panelMetadatos
					.add(getLabel("IdEspecifico", this.IdEspecifico));
			this.panelMetadatos.add(getContent(eni.getIdEspecifico(),
					this.IdEspecifico));
			altoPanel = altoPanel + 30;
		}

		// ORGANISMO
		if (eni.getOrganos() != null && !eni.getOrganos().isEmpty()) {
			this.panelMetadatos.add(getLabel("Órgano", this.organo));
			this.panelMetadatos.add(getOrgano(eni.getOrganos(), this.organo));
			altoPanel = altoPanel + 30;
		}

		// INTERESADOS
		if (eni.getInteresados() != null && !eni.getInteresados().isEmpty()) {
			this.panelMetadatos.add(getLabel("Interesados", this.interesados));
			this.panelMetadatos.add(getInteresados(eni.getInteresados(),
					this.interesados));
			altoPanel = altoPanel + 30;
		}

		// FECHA APERTURA
		if (eni.getFechaApertura() != null) {
			this.panelMetadatos.add(getLabel("Fecha Apertura", this.fecha));
			this.panelMetadatos
					.add(getFecha(eni.getFechaApertura(), this.fecha));
			altoPanel = altoPanel + 30;
		}

		// ESTADO
		if (eni.getEstado().getContent() != null) {
			this.panelMetadatos.add(getLabel("Estado", this.estado));
			this.panelMetadatos.add(getEstado(eni.getEstado().getContent(),
					this.estado));
			altoPanel = altoPanel + 30;
		}

		// CLASIFICACIÓN
		if (eni.getClasificacion() != null) {
			this.panelMetadatos.add(getLabel("Clasificación",
					this.clasificacion));
			this.panelMetadatos.add(getContent(eni.getClasificacion(),
					this.clasificacion));
			altoPanel = altoPanel + 30;
		}

		// VERSION NTI
		if (eni.getVersionNTI() != null) {
			this.panelMetadatos.add(getLabel("Versión NTI", this.versionNTI));
			this.panelMetadatos.add(getContent(eni.getVersionNTI(),
					this.versionNTI));
			altoPanel = altoPanel + 30;
		}

		// Visualización Indice
		if (eni.getVisualizacionIndice() != null) {
			this.panelMetadatos.add(getLabel("Visualización",
					this.descargaLabel));
			this.panelMetadatos.add(
					getDescarga(eni.getVisualizacionIndice().getValorBinario(),
							eni.getVisualizacionIndice().getNombreFormato(),
							ruta), null);
			altoPanel = altoPanel + 60;
		}

		// IndiceExpediente
		if (eni.getIndiceExpediente() != null) {
			this.panelMetadatos.add(getPanelIndiceExpediente(eni));
		}

		this.panelMetadatos.setBounds(new Rectangle(10, 100, 700,
				altoPanel + 20));
		return this.panelMetadatos;
	}

	/**
	 * Gets the panel indice expediente.
	 * 
	 * @param eni
	 *            the eni
	 * @return the panel indice expediente
	 */
	private JPanel getPanelIndiceExpediente(ExpedienteEni eni) {
		posPanelInc = altoPanel;
		heightBloque = 0;
		posHorizontalLabel = 30;
		posHorizontalContent = 120;

		JPanel panelIndiceExpediente = new JPanel();

		panelIndiceExpediente.setLayout(null);
		if (eni.getIndiceExpediente().getId() != null) {
			panelIndiceExpediente.setBorder(BorderFactory
					.createTitledBorder("Indice del Expediente: "
							+ eni.getIndiceExpediente().getId()));
			altoPanel = altoPanel + 30;
		} else {
			panelIndiceExpediente.setBorder(BorderFactory
					.createTitledBorder("Indice del Expediente"));
			altoPanel = altoPanel + 30;
		}

		// FECHA INDICE
		if (eni.getIndiceExpediente().getFechaIndice() != null) {
			this.panelMetadatos.add(getLabel("Fecha Índice", this.fechaIndice));
			this.panelMetadatos.add(getFecha(eni.getIndiceExpediente()
					.getFechaIndice(), this.fechaIndice));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
		}

		// NUMERO DE FIRMAS
		if (eni.getIndiceExpediente().getFirmas() != null
				&& !eni.getIndiceExpediente().getFirmas().isEmpty()) {
			this.panelMetadatos.add(getLabel("Nº Firmas", this.nFirmas));
			this.panelMetadatos.add(getContent(
					Integer.toString(eni.getIndiceExpediente().getFirmas()
							.size()), this.nFirmas));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
		}

		// DOCUMENTOS
		if (eni.getIndiceExpediente().getDocumentosIndice() != null) {
			List<DocumentoIndice> documentos = eni.getIndiceExpediente()
					.getDocumentosIndice();
			if (documentos != null && !documentos.isEmpty()) {
				for (DocumentoIndice doc : documentos) {
					altoPanel = altoPanel + 30;
					heightBloque = heightBloque + 30;
					posHorizontalLabel = 40;
					posHorizontalContent = 170;
					widhtLabel = 140;
					widhtContent = 500;
					panelIndiceExpediente.add(getPanelDocumentos(doc));
				}
			}
		}

		// CARPETAS
		if (eni.getIndiceExpediente().getCarpetasIndice() != null) {
			List<CarpetaIndice> carpetas = eni.getIndiceExpediente()
					.getCarpetasIndice();
			if (carpetas != null && !carpetas.isEmpty()) {
				for (CarpetaIndice carp : carpetas) {
					altoPanel = altoPanel + 30;
					heightBloque = heightBloque + 30;
					posHorizontalLabel = 40;
					posHorizontalContent = 170;
					widhtLabel = 140;
					widhtContent = 500;
					panelIndiceExpediente.add(getPanelCarpetas(carp));
				}
			}
		}

		// EXPEDIENTES
		if (eni.getIndiceExpediente().getExpedientesIndice() != null) {
			List<ExpedienteIndice> expedientes = eni.getIndiceExpediente()
					.getExpedientesIndice();
			if (expedientes != null && !expedientes.isEmpty()) {
				for (ExpedienteIndice exp : expedientes) {
					altoPanel = altoPanel + 30;
					heightBloque = heightBloque + 30;
					posHorizontalLabel = 40;
					posHorizontalContent = 170;
					widhtLabel = 140;
					widhtContent = 500;
					panelIndiceExpediente.add(getPanelExpedientes(exp));
				}
			}
		}

		panelIndiceExpediente.setBounds(new Rectangle(10, posPanelInc, 680,
				altoPanel - posPanelInc + 10));
		return panelIndiceExpediente;
	}

	/**
	 * Gets the panel documentos.
	 *
	 * @param doc the doc
	 * @return the panel documentos
	 */
	private JPanel getPanelDocumentos(DocumentoIndice doc) {
		posBloqueDoc = heightBloque;

		JPanel panelDocumentos = new JPanel();

		panelDocumentos.setLayout(null);
		if (doc.getId() != null) {
			panelDocumentos.setBorder(BorderFactory
					.createTitledBorder("Documento: " + doc.getId()));
		} else {
			panelDocumentos.setBorder(BorderFactory
					.createTitledBorder("Documento"));
		}

		// IDENTIFICADOR DOCUMENTO
		if (doc.getIdentificadorDocumento() != null) {
			this.panelMetadatos.add(getLabel("Identificador",
					this.docIdentificador));
			this.panelMetadatos.add(getContent(doc.getIdentificadorDocumento(),
					this.docIdentificador));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
		}

		// VALOR HUELLA
		if (doc.getValorHuella() != null) {
			this.panelMetadatos.add(getLabel("Valor Huella",
					this.docValorHuella));
			this.panelMetadatos.add(getContent(doc.getValorHuella(),
					this.docValorHuella));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
		}

		// FUNCION RESUMEN
		if (doc.getFuncionResumen() != null) {
			this.panelMetadatos.add(getLabel("Funcion Resumen",
					this.docFuncionResumen));
			this.panelMetadatos.add(getContent(doc.getFuncionResumen(),
					this.docFuncionResumen));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
		}

		// FECHA INCORPORACION
		if (doc.getFuncionResumen() != null) {
			this.panelMetadatos.add(getLabel("Fecha Incorporación",
					this.docFechaIncorporacion));
			this.panelMetadatos.add(getFecha(
					doc.getFechaIncorporacionExpediente(),
					this.docFechaIncorporacion));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
		}

		// ORDEN
		if (doc.getOrdenDocumentoExpediente() != null) {
			this.panelMetadatos.add(getLabel("Orden", this.docOrden));
			this.panelMetadatos.add(getContent(
					doc.getOrdenDocumentoExpediente(), this.docOrden));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
		}

		panelDocumentos.setBounds(new Rectangle(10, posBloqueDoc, 660,
				heightBloque + 30 - posBloqueDoc));
		return panelDocumentos;
	}

	/**
	 * Gets the panel carpetas.
	 *
	 * @param carp the carp
	 * @return the panel carpetas
	 */
	private JPanel getPanelCarpetas(CarpetaIndice carp) {
		posBloqueCarp = heightBloque;
		posDoc = 30;

		JPanel panelCarpetas = new JPanel();

		panelCarpetas.setLayout(null);
		if (carp.getId() != null) {
			panelCarpetas.setBorder(BorderFactory
					.createTitledBorder("Carpeta: " + carp.getId()));
		} else {
			panelCarpetas
					.setBorder(BorderFactory.createTitledBorder("Carpeta"));
		}

		// Identificador Carpeta
		if (carp.getIdentificadorCarpeta() != null) {
			this.panelMetadatos.add(getLabel("Identificador",
					this.carpIdentificador));
			this.panelMetadatos.add(getContent(carp.getIdentificadorCarpeta(),
					this.carpIdentificador));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// Carpetas
		if (carp.getCarpetasIndice() != null
				&& !carp.getCarpetasIndice().isEmpty()) {
			this.panelMetadatos.add(getLabel("Nº Carpetas",
					this.carpIdentificador));
			this.panelMetadatos.add(getContent(
					Integer.toString(carp.getCarpetasIndice().size()),
					this.carpIdentificador));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// Expedientes
		if (carp.getExpedientesIndice() != null
				&& !carp.getExpedientesIndice().isEmpty()) {
			this.panelMetadatos.add(getLabel("Nº Expedientes",
					this.carpIdentificador));
			this.panelMetadatos.add(getContent(
					Integer.toString(carp.getExpedientesIndice().size()),
					this.carpIdentificador));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// Documentos
		if (carp.getDocumentosIndice() != null
				&& !carp.getDocumentosIndice().isEmpty()) {
			List<DocumentoIndice> documentos = carp.getDocumentosIndice();
			if (documentos != null && !documentos.isEmpty()) {
				for (DocumentoIndice doc : documentos) {
					altoPanel = altoPanel + 30;
					heightBloque = heightBloque + 30;
					posHorizontalLabel = 50;
					posHorizontalContent = 180;
					widhtLabel = 130;
					widhtContent = 480;
					panelCarpetas.add(getPanelDocumentos(doc, posDoc));
					posDoc = posDoc + 30;
				}
				altoPanel = altoPanel + 10;
				heightBloque = heightBloque + 10;
			}
		}

		panelCarpetas.setBounds(new Rectangle(10, posBloqueCarp, 660,
				heightBloque + 30 - posBloqueCarp));
		return panelCarpetas;
	}

	/**
	 * Gets the panel expedientes.
	 *
	 * @param exp the exp
	 * @return the panel expedientes
	 */
	private JPanel getPanelExpedientes(ExpedienteIndice exp) {
		posBloqueExp = heightBloque;
		posDoc = 30;

		JPanel panelExpediente = new JPanel();

		panelExpediente.setLayout(null);
		if (exp.getId() != null) {
			panelExpediente.setBorder(BorderFactory
					.createTitledBorder("Expediente: " + exp.getId()));
		} else {
			panelExpediente.setBorder(BorderFactory
					.createTitledBorder("Expediente"));
		}

		// Fecha
		if (exp.getFechaIndice() != null) {
			this.panelMetadatos.add(getLabel("Fecha Índice", this.expFecha));
			this.panelMetadatos.add(getFecha(exp.getFechaIndice(),
					this.expFecha));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// Carpetas
		if (exp.getExpedientesIndice() != null
				&& !exp.getExpedientesIndice().isEmpty()) {
			this.panelMetadatos.add(getLabel("Nº Carpetas",
					this.carpIdentificador));
			this.panelMetadatos.add(getContent(
					Integer.toString(exp.getCarpetasIndice().size()),
					this.carpIdentificador));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// Expedientes
		if (exp.getExpedientesIndice() != null
				&& !exp.getExpedientesIndice().isEmpty()) {
			this.panelMetadatos.add(getLabel("Nº Expedientes",
					this.carpIdentificador));
			this.panelMetadatos.add(getContent(
					Integer.toString(exp.getExpedientesIndice().size()),
					this.carpIdentificador));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// Documentos
		if (exp.getExpedientesIndice() != null
				&& !exp.getDocumentosIndice().isEmpty()) {
			List<DocumentoIndice> documentos = exp.getDocumentosIndice();
			if (documentos != null && !documentos.isEmpty()) {
				for (DocumentoIndice doc : documentos) {
					altoPanel = altoPanel + 30;
					heightBloque = heightBloque + 30;
					posHorizontalLabel = 50;
					posHorizontalContent = 180;
					widhtLabel = 130;
					widhtContent = 480;
					panelExpediente.add(getPanelDocumentos(doc, posDoc));
					posDoc = posDoc + 30;
					// /
					// this.panelMetadatos.add(getLabel(posHorizontalLabel,
					// altoPanel, widhtLabel, "Documento",
					// this.carpIdentificador));
					// this.panelMetadatos.add(getContent(posHorizontalContent,
					// altoPanel, widhtContent, doc.getIdentificadorDocumento(),
					// this.carpIdentificador));
					// altoPanel = altoPanel+30;
					// heightBloque=heightBloque+30;
				}
				altoPanel = altoPanel + 10;
				heightBloque = heightBloque + 10;
			}
		}

		panelExpediente.setBounds(new Rectangle(10, posBloqueExp, 660,
				heightBloque + 30 - posBloqueExp));
		return panelExpediente;
	}

	/**
	 * Gets the indice expediente id label.
	 *
	 * @param label the label
	 * @param jlabel the jlabel
	 * @return the indice expediente id label
	 */
	private JLabel getLabel(String label, JLabel jlabel) {
		if (jlabel == null) {
			jlabel = new JLabel();
			jlabel.setText(label + ":");
			jlabel.setBounds(new Rectangle(posHorizontalLabel, altoPanel,
					widhtLabel, 20));
		}
		return jlabel;
	}

	/**
	 * Gets the documento id.
	 *
	 * @param documento the documento
	 * @param jlabel the jlabel
	 * @return the documento id
	 */
	private JLabel getContent(String documento, JLabel jlabel) {
		if (jlabel == null) {
			jlabel = new JLabel();
			jlabel.setText(documento);
			jlabel.setBounds(new Rectangle(posHorizontalContent, altoPanel,
					widhtContent, 20));
			jlabel.setEnabled(Boolean.FALSE);
		}
		return jlabel;
	}

	/**
	 * Gets the organo.
	 *
	 * @param organos the organos
	 * @param jlabel the jlabel
	 * @return the organo
	 */
	private JLabel getOrgano(List<String> organos, JLabel jlabel) {
		if (jlabel == null) {
			jlabel = new JLabel();
			jlabel.setBounds(new Rectangle(posHorizontalContent, altoPanel,
					widhtContent, 20));
			if (organos != null && !organos.isEmpty()) {
				int cont = 0;
				for (String org : organos) {
					String contenidoOrg = jlabel.getText();
					if (cont != 0) {
						contenidoOrg = contenidoOrg + ", ";
					}
					cont++;
					jlabel.setText(contenidoOrg + org);
				}
			}
			jlabel.setEnabled(Boolean.FALSE);
		}
		return jlabel;
	}

	/**
	 * Gets the interesados.
	 *
	 * @param interesados the interesados
	 * @param jlabel the jlabel
	 * @return the interesados
	 */
	private JLabel getInteresados(List<InteresadoEni> interesados, JLabel jlabel) {
		if (jlabel == null) {
			jlabel = new JLabel();
			jlabel.setBounds(new Rectangle(posHorizontalContent, altoPanel,
					widhtContent, 20));
			if (interesados != null && !interesados.isEmpty()) {
				int cont = 0;
				for (InteresadoEni interesado : interesados) {
					String contenidoInte = jlabel.getText();
					if (cont != 0) {
						contenidoInte = contenidoInte + ", ";
					}
					cont++;
					jlabel.setText(contenidoInte
							+ interesado.getIdentificador());
				}
			}
			jlabel.setEnabled(Boolean.FALSE);
		}
		return jlabel;
	}

	/**
	 * Gets the fecha.
	 *
	 * @param date the date
	 * @param jlabel the jlabel
	 * @return the fecha
	 */
	private JLabel getFecha(Date date, JLabel jlabel) {
		if (jlabel == null) {
			jlabel = new JLabel();
			jlabel.setBounds(new Rectangle(new Rectangle(posHorizontalContent,
					altoPanel, widhtContent, 20)));
			SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
			String strFecha = sdf.format(date);
			jlabel.setText(strFecha);
			jlabel.setEnabled(Boolean.FALSE);
		}
		return jlabel;
	}

	/**
	 * Gets the estado.
	 *
	 * @param estado the estado
	 * @param jlabel the jlabel
	 * @return the estado
	 */
	private JLabel getEstado(String estado, JLabel jlabel) {
		if (jlabel == null) {
			jlabel = new JLabel();
			String nombreEstado = "";
			if (estado.equals("E01")) {
				nombreEstado = "E01 - Abierto";
			} else if (estado.equals("E02")) {
				nombreEstado = "E02 - Cerrado";
			} else if (estado.equals("E03")) {
				nombreEstado = "E03 - Indice para remisión cerrado";
			}
			jlabel.setText(nombreEstado);
			jlabel.setBounds(new Rectangle(posHorizontalContent, altoPanel,
					widhtContent, 20));
			jlabel.setEnabled(Boolean.FALSE);
		}
		return jlabel;
	}

	/**
	 * Gets the panel documentos.
	 *
	 * @param doc the doc
	 * @param posIni the pos ini
	 * @return the panel documentos
	 */
	private JPanel getPanelDocumentos(DocumentoIndice doc, int posIni) {
		posBloqueDoc = posDoc;

		JPanel panelDocumentos = new JPanel();

		panelDocumentos.setLayout(null);
		if (doc.getId() != null) {
			panelDocumentos.setBorder(BorderFactory
					.createTitledBorder("Documento: " + doc.getId()));
		} else {
			panelDocumentos.setBorder(BorderFactory
					.createTitledBorder("Documento"));
		}

		// IDENTIFICADOR DOCUMENTO
		if (doc.getIdentificadorDocumento() != null) {
			this.panelMetadatos.add(getLabel("Identificador",
					this.docIdentificador));
			this.panelMetadatos.add(getContent(doc.getIdentificadorDocumento(),
					this.docIdentificador));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// VALOR HUELLA
		if (doc.getValorHuella() != null) {
			this.panelMetadatos.add(getLabel("Valor Huella",
					this.docValorHuella));
			this.panelMetadatos.add(getContent(doc.getValorHuella(),
					this.docValorHuella));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// FUNCION RESUMEN
		if (doc.getFuncionResumen() != null) {
			this.panelMetadatos.add(getLabel("Funcion Resumen",
					this.docFuncionResumen));
			this.panelMetadatos.add(getContent(doc.getFuncionResumen(),
					this.docFuncionResumen));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// FECHA INCORPORACION
		if (doc.getFuncionResumen() != null) {
			this.panelMetadatos.add(getLabel("Fecha Incorporación",
					this.docFechaIncorporacion));
			this.panelMetadatos.add(getFecha(
					doc.getFechaIncorporacionExpediente(),
					this.docFechaIncorporacion));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		// ORDEN
		if (doc.getOrdenDocumentoExpediente() != null) {
			this.panelMetadatos.add(getLabel("Orden", this.docOrden));
			this.panelMetadatos.add(getContent(
					doc.getOrdenDocumentoExpediente(), this.docOrden));
			altoPanel = altoPanel + 30;
			heightBloque = heightBloque + 30;
			posDoc = posDoc + 30;
		}

		panelDocumentos.setBounds(new Rectangle(10, posBloqueDoc, 640, posDoc
				+ 30 - posBloqueDoc));
		return panelDocumentos;
	}

	/**
	 * Gets the descarga.
	 *
	 * @param contenido the contenido
	 * @param formato the formato
	 * @param ruta the ruta
	 * @return the enlace link
	 */
	private JButton getDescarga(final byte[] contenido, final String formato,
			final String ruta) {
		if (this.descarga == null) {
			this.descarga = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/descarga.png"));
			this.descarga.setIcon(icon);
			this.descarga.setIconTextGap(5);
			this.descarga.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.descarga.setText("Descargar");
			this.descarga.setBounds(new Rectangle(posHorizontalContent,
					altoPanel, 150, 40));
			final String destino = ruta.substring(0,
					ruta.lastIndexOf("."))
					+ "." + formato;
			this.descarga.setToolTipText("El documento se descargará en la ruta: "+destino);
			this.descarga.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						
						FileOutputStream fileOuputStream = new FileOutputStream(
								destino);
						fileOuputStream.write(contenido);
						fileOuputStream.close();
						JOptionPane.showMessageDialog(null,
								"Expediente descargado correctamente guardado en: "
										+ destino, "INFORMACIÓN",
								Constantes.INFO);
						File path = new File(destino);
						Desktop.getDesktop().open(path);
					} catch (FileNotFoundException ex) {
						JOptionPane.showMessageDialog(null,
								"El fichero no existe", "ERROR",
								Constantes.ERROR);
					} catch (IOException ex) {
						JOptionPane.showMessageDialog(null,
								"Error al escribir en fichero", "ERROR",
								Constantes.ERROR);
					}
				}
			});
		}
		return this.descarga;
	}

	/**
	 * Gets the volver.
	 * 
	 * @return the volver
	 */
	private JButton getCerrar() {
		if (this.cerrar == null) {
			this.cerrar = new JButton();
			Icon icon = new ImageIcon(getClass().getResource(
					"/imagenes/cancel.png"));
			this.cerrar.setIcon(icon);
			this.cerrar.setIconTextGap(5);
			this.cerrar.setCursor(new Cursor(Cursor.HAND_CURSOR));
			this.cerrar.setText("Cerrar");
			this.cerrar.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					pantallaActual.dispose();
					((JFormReadExp) pantallaAnterior).habilitarFormulario();
				}
			});
		}
		return this.cerrar;
	}

}